/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

// LafterDlg.h : header file
//

#include "TciGrabber.h"
#include "UBitMap.h"
#include "Vision.h"

/////////////////////////////////////////////////////////////////////////////
// CLafterDlg dialog
class CStaticFrameDialog;
class CStaticFrameBBDialog;
class CHistogramDialog;
class CVision;

class CLafterDlg : public CDialog
{
	// Construction
	
protected:
	int m_MinX, m_MinY;
	BOOL bCleanedUp;
protected:
	long OnHGGoodbye(UINT wParam, long lParam);
	long OnDDGoodbye(UINT wParam, long lParam);
	
private:
	BOOL m_bWindowsClosed;
	CStaticFrameDialog* m_pLiveDlg;
	CStaticFrameBBDialog* m_pEstimationDlg;
	CStaticFrameDialog* m_pFaceConnectDlg;
	CHistogramDialog* m_pHistogramDlg;
	CVision				 m_vision;
	
public:
	CLafterDlg(CWnd* pParent = NULL);	// standard constructor
	~CLafterDlg();
	
	// Dialog Data
	//{{AFX_DATA(CLafterDlg)
	enum { IDD = IDD_LAFTER_DIALOG };
	BOOL	m_bEstimation;
	BOOL	m_bFaceHisto;
	BOOL	m_bLive;
	BOOL	m_bFaceConnect;
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLafterDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	HICON m_hIcon;
	
	// Generated message map functions
	//{{AFX_MSG(CLafterDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnLive();
	afx_msg void OnFacehisto();
	afx_msg void OnFaceconnect();
	afx_msg void OnEstimation();
	afx_msg void OnQuit();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
		
protected:
	VTciGrabber grabber;
	
private:
	void CleanUp();
	void GoodBye();
};
