/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

///////////////////////////////////////////////////////////////////////////
// Filename	: StaticFrame.cpp
// Created	: Tuesday, June 17th, 1997
// Description: A frame class to display images. The frame is glued to a dialog.
// 
// by Vasanth Philomin 1997, vasi@cs.umd.edu
///////////////////////////////////////////////////////////////////////////
// StaticFrame.cpp : implementation file
//

#include "stdafx.h"
#include "StaticFrame.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CStaticFrame, CStatic)

/////////////////////////////////////////////////////////////////////////////
// CStaticFrame


CStaticFrame::~CStaticFrame()
{
}


BEGIN_MESSAGE_MAP(CStaticFrame, CStatic)
//{{AFX_MSG_MAP(CStaticFrame)
ON_WM_PAINT()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStaticFrame message handlers

CStaticFrame::CStaticFrame(CDialog *pDlg) 
{
	m_pDlg = pDlg;
}

BOOL CStaticFrame::Create(BITMAPINFO_8 &bmInfo, BOOL bMatchScreen)
{
	CDisplay::Create( bmInfo, bMatchScreen );
	SetWindowPos(&wndTop, 0,0,bmInfo.bmiHeader.biWidth, bmInfo.bmiHeader.biHeight, SWP_NOZORDER | SWP_NOMOVE);
	
	return TRUE;
}

void CStaticFrame::CenterWindow( CWnd* pAlternateOwner )
{
	CStatic::CenterWindow( pAlternateOwner );
}


void CStaticFrame::OnPaint() 
{
	// Proceed only if Dib is valid
	if (m_bValidDib == NEVER)
		return;
	
	
	CPaintDC dc(this); // device context for painting
	
	m_dib.Draw(&dc, 0, 0);
	
	
	if (m_bValidDib == ONCE)
		m_bValidDib = NEVER;
	
	// Do not call CFrameWnd::OnPaint() for painting messages
}
