/***************************************************************************
*
* Copyright 1997 by  the  Massachusetts Institute  of Technology.   All
* rights reserved.
*
* Developed  by the Perceptual Computing Section
* at the Media Laboratory, MIT, Cambridge, Massachusetts.
*
* Permission to use, copy,  or modify this software and  its documentation
* for  educational  and  research purposes only and without fee  is hereby
* granted, provided  that this copyright notice and the original authors's
* names appear  on all copies and supporting documentation.  If individual
* files are  separated from  this  distribution directory  structure, this
* copyright notice must be included.  For any other uses of this software,
* in original or  modified form, including but not limited to distribution
* in whole or in  part, specific  prior permission  must be  obtained from
* MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
*   basis  of  a commercial  software  or  hardware product  without first
* obtaining appropriate licenses  from MIT.  MIT. makes no representations
* about the suitability of this  software for any purpose.  It is provided
* "as is" without express or implied warranty.
*
**************************************************************************/

//
//           File : UErrors.cpp
//           Date : 02 07 97
//           Goal : see UErrors.h
//
//					 Tabs : 2
//
//    Main modifs :
//
//  Nuria Oliver 1997, nuria@media.mit.edu

#include "stdafx.h"
// unit include
#include "UErrors.h"

static const int kMaxStrLen		= 256;
static const int kMaxStrNb		= 50;
static       int kNumErrors     = 5;

class ErrCouple
{
public :
	
	ErrorNumber		code;
	char					str[kMaxStrLen];
};

static ErrCouple	gErrorStrings[kMaxStrNb] =
{
	{kErrNoErr,				""},
	{kErrUnknown,			"Unknown error"},
	{kErrMemFull,			"Memory full error"},
	{kErrFileErr,			"FileSystem error"},
	{kErrRegErr,			"Error registering error"}
};




//
//		StringError
//

char* ErrorString (ErrorNumber err)
{
	int i;
	
	for (i=0; i<kNumErrors; i++)
		if (err == gErrorStrings[i].code)
			return gErrorStrings[i].str;
		
		return "";
}


//
//		RegisterErrorString
//

ErrorNumber RegisterErrorString (ErrorNumber e, char* s)
{
    ErrorNumber res=kErrNoErr;
    if ( kNumErrors < (kMaxStrNb-1) ) {
		// try to register new error
		// if it does not exist already
		if ( strcmp( ErrorString( e ), s ) != 0 ) {
			if ( strlen( s ) <  kMaxStrLen ) {
				gErrorStrings[kNumErrors].code = e;
				strcpy( gErrorStrings[kNumErrors++].str, s );
			} else {
				res=kErrRegErr;
			}
		}
    } else {
		res=kErrRegErr;
    }
    return res;
};

